From d9317eb06b01bc767a9045cebf52d978e3fcad6b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 27 2020 07:30:40 +0000
Subject: [PATCH 1791/2232] Fully qualify Sized and Unpin traits in generated code


This avoids problematic changes in meaning if the caller's bridge
contains a type called "Sized" or "Unpin".

---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 15562ac..96cd15a 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -329,12 +329,18 @@ fn expand_cxx_type_assert_pinned(ety: &ExternType) -> TokenStream {
                 fn infer() {}
             }
 
-            impl<T: ?Sized> __AmbiguousIfImpl<()> for T {}
+            impl<T> __AmbiguousIfImpl<()> for T
+            where
+                T: ?::std::marker::Sized
+            {}
 
             #[allow(dead_code)]
             struct __Invalid;
 
-            impl<T: ?Sized + Unpin> __AmbiguousIfImpl<__Invalid> for T {}
+            impl<T> __AmbiguousIfImpl<__Invalid> for T
+            where
+                T: ?::std::marker::Sized + ::std::marker::Unpin,
+            {}
 
             // If there is only one specialized trait impl, type inference with
             // `_` can be resolved and this can compile. Fails to compile if

